package dev.shadowsoffire.apotheosis.adventure.commands;

import com.mojang.brigadier.exceptions.CommandSyntaxException;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.entity.player.Player;
import dev.shadowsoffire.apotheosis.adventure.loot.LootController;
import java.util.Map;
import dev.shadowsoffire.apotheosis.adventure.affix.AffixHelper;
import java.util.Collections;
import dev.shadowsoffire.apotheosis.adventure.loot.RarityRegistry;
import dev.shadowsoffire.apotheosis.adventure.loot.LootRarity;
import com.mojang.brigadier.context.CommandContext;
import com.mojang.brigadier.arguments.ArgumentType;
import net.minecraft.commands.arguments.ResourceLocationArgument;
import net.minecraft.commands.Commands;
import com.mojang.brigadier.builder.LiteralArgumentBuilder;
import net.minecraft.commands.CommandSourceStack;
import com.mojang.brigadier.suggestion.SuggestionProvider;

public class LootifyCommand
{
    public static final SuggestionProvider<CommandSourceStack> SUGGEST_RARITY;
    
    public static void register(final LiteralArgumentBuilder<CommandSourceStack> root) {
        root.then(((LiteralArgumentBuilder)Commands.m_82127_("lootify").requires(c -> c.m_6761_(2))).then(Commands.m_82129_("rarity", (ArgumentType)ResourceLocationArgument.m_106984_()).suggests((SuggestionProvider)LootifyCommand.SUGGEST_RARITY).executes(c -> {
            final Player p = (Player)((CommandSourceStack)c.getSource()).m_81375_();
            final LootRarity rarity = (LootRarity)RarityRegistry.INSTANCE.getValue(ResourceLocationArgument.m_107011_(c, "rarity"));
            final ItemStack stack = p.m_21205_();
            AffixHelper.setAffixes(stack, (Map)Collections.emptyMap());
            LootController.createLootItem(stack, rarity, p.m_9236_().f_46441_);
            return 0;
        })));
    }
    
    static {
        SUGGEST_RARITY = RarityCommand.SUGGEST_RARITY;
    }
}
